org.apache.solr.client.solrj.cloud.autoscaling

## Interface SolrCloudManager

All Superinterfaces:
  AutoCloseable, Closeable, SolrCloseable

All Known Implementing Classes:
  DelegatingCloudManager, SolrClientCloudManager

    public interface SolrCloudManager
    extends SolrCloseable

This interface abstracts the access to a SolrCloud cluster, including interactions with Zookeeper, Solr and generic HTTP calls.

This abstraction should be used when possible instead of directly referencing ZK, Solr and HTTP.

### Method Summary

All Methods Instance Methods Abstract Methods Default Methods
`default void` `close()`
`ClusterStateProvider` `getClusterStateProvider()`
`DistribStateManager` `getDistribStateManager()`
`DistributedQueueFactory` `getDistributedQueueFactory()`
`NodeStateProvider` `getNodeStateProvider()`
`byte[]` `httpRequest(String url, SolrRequest.METHOD method, Map<String,String> headers, String payload, int timeout, boolean followRedirects)`
`SolrResponse` `request(SolrRequest req)`

### Methods inherited from interface org.apache.solr.common.SolrCloseable

`isClosed`

### Method Detail

#### getClusterStateProvider

    ClusterStateProvider getClusterStateProvider()

#### getNodeStateProvider

    NodeStateProvider getNodeStateProvider()

#### getDistribStateManager

    DistribStateManager getDistribStateManager()

#### getDistributedQueueFactory

    DistributedQueueFactory getDistributedQueueFactory()

#### request

    SolrResponse request(SolrRequest req)
                  throws IOException

Throws:
  `IOException`

#### httpRequest

    byte[] httpRequest(String url,
                       SolrRequest.METHOD method,
                       Map<String,String> headers,
                       String payload,
                       int timeout,
                       boolean followRedirects)
                throws IOException

Throws:
  `IOException`

#### close

    default void close()

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`